/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
var __webpack_exports__ = {};

;// external "fastly:env"
const external_fastly_env_namespaceObject = require("fastly:env");
;// external "fastly:experimental"
const external_fastly_experimental_namespaceObject = require("fastly:experimental");
;// ./src/index.js



addEventListener("fetch", (event) => event.respondWith(handleRequest(event)));

async function handleRequest(event) {
    let req = event.request;
    let url = new URL(req.url);

    // Define a list of protected URLs
    const protectedUrls = [
        "/camping-gear/outdoor-furniture-gear.html",
        "/camping-chair-foldable.html",
    ];

    // Check if the request URL path is in the protected list
    if (protectedUrls.includes(url.pathname)) {
        // Validate user authentication
        let validationResponse = await validateUser(req);

        if (validationResponse.ok) {
            // User is validated, continue processing normally
            return (0,external_fastly_experimental_namespaceObject.pass)(req);
        } else {
            // Redirect to login page if validation fails
            return Response.redirect("https://hyva-rdp-demo.atwixlabs.tech/customer/account/login", 302);
        }
    }

    // If the URL is not protected, process the request as normal
    return (0,external_fastly_experimental_namespaceObject.pass)(req);
}

// Function to validate the user by making an external API call
async function validateUser(req) {
    const validationUrl = "https://hyva-rdp-demo.atwixlabs.tech/grapql";

    try {
        let validationReq = new Request(validationUrl, {
            method: "POST",
            headers: {
                "Authorization": req.headers.get("Authorization") || "",
                "Content-Type": "application/json",
            },
            body: JSON.stringify({ url: req.url }),
        });

        return await (0,external_fastly_experimental_namespaceObject.fetch)(validationReq);
    } catch (error) {
        console.error("Validation request failed:", error);
        return Response.redirect("https://hyva-rdp-demo.atwixlabs.tech/customer/account/login", 302);
      }
}
var __webpack_export_target__ = this;
for(var __webpack_i__ in __webpack_exports__) __webpack_export_target__[__webpack_i__] = __webpack_exports__[__webpack_i__];
if(__webpack_exports__.__esModule) Object.defineProperty(__webpack_export_target__, "__esModule", { value: true });
/******/ })()
;